Index: /branches/HTM-4.0.1-VSP-dev0/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 193)
@@ -120,4 +120,25 @@
 #endif
 
+#if FIX_MEM_LEAKS
+ if ( m_pchCameraParameterFile != NULL )
+   free ( m_pchCameraParameterFile ); 
+
+ if ( m_pchBaseViewCameraNumbers != NULL )
+   free ( m_pchBaseViewCameraNumbers ); 
+
+ if ( m_pchdQPFile      != NULL ) 
+   free ( m_pchdQPFile      );
+
+ if ( m_pchColumnWidth  != NULL ) 
+   free ( m_pchColumnWidth  );
+
+ if ( m_pchRowHeight    != NULL ) 
+   free ( m_pchRowHeight    );
+
+ if ( m_scalingListFile != NULL ) 
+   free ( m_scalingListFile );
+
+#endif   
+
 }
 
@@ -168,4 +189,20 @@
     in>>entry.m_interViewRefPosL1[i];
   }
+#if VSP_CFG
+  in>>entry.m_numVSPRefPics;
+  for( Int i = 0; i < entry.m_numVSPRefPics; i++ )
+  {
+    in>>entry.m_VSPRefPics[i];
+  }
+  for( Int i = 0; i < entry.m_numVSPRefPics; i++ )
+  {
+    in>>entry.m_VSPRefPosL0[i];
+  }
+  for( Int i = 0; i < entry.m_numVSPRefPics; i++ )
+  {
+    in>>entry.m_VSPRefPosL1[i];
+  }
+#endif
+
   return in;
 }
@@ -339,5 +376,19 @@
   ("AllowNegDist",                    m_bAllowNegDist           , true          , "Allow negative Distortion in VSO")
 #endif
-
+#if LGE_WVSO_A0119
+  ("WVSO",                            m_bUseWVSO                , false         , "Use depth fidelity term for VSO" )
+  ("VSOWeight",                       m_iVSOWeight              , 10            , "Synthesized View Distortion Change weight" )
+  ("VSDWeight",                       m_iVSDWeight              , 1             , "View Synthesis Distortion estimate weight" )
+  ("DWeight",                         m_iDWeight                , 1             , "Depth Distortion weight" )
+#endif
+
+#if OL_DEPTHLIMIT_A0044
+  ("DPL",                             m_bDepthPartitionLimiting , false         , "Use DepthPartitionLimiting" )
+#endif
+#endif
+
+#if VSP_N
+  ("VSP",                             m_bUseVSP                 , false         , "Use VSP" )    
+  ("VSPDepthDisable",                 m_bVSPDepthDisable        , false         , "Use VSP Depth Disable" )    
 #endif
 
@@ -498,5 +549,5 @@
   m_pchRowHeight = cfg_RowHeight.empty() ? NULL : strdup(cfg_RowHeight.c_str());
   m_scalingListFile = cfg_ScalingListFile.empty() ? NULL : strdup(cfg_ScalingListFile.c_str());
-
+  
   if ( m_bUsingDepthMaps )
   {
@@ -648,4 +699,7 @@
 #endif
 
+#if LGE_WVSO_A0119
+  m_bUseWVSO = m_bUseVSO && m_bUseWVSO && m_bUsingDepthMaps;
+#endif
   xCleanUpVectors();
 
@@ -1107,4 +1161,49 @@
   }
   xConfirmPara( bErrorIvpEnhV, "Invalid inter-view coding structure for enhancement views given" );
+
+#if VSP_CFG
+  // validate vsp refs
+  Bool bErrorVspEnhV = false;
+  if( m_iNumberOfViews > 1 )
+  {
+    for( Int k = 1; k < m_iNumberOfViews; k++ )
+    {
+      for( Int i = 0; i < MAX_GOP+1; i++ )
+      {
+        if( m_GOPListsMvc[k][i].m_numVSPRefPics < 0 || m_GOPListsMvc[k][i].m_numVSPRefPics > 1 )
+        {
+          printf( "\nError: m_numVSPRefPics < 0 or m_numVSPRefPics > 1 \n" );
+          bErrorVspEnhV = true;
+        }
+
+        for( Int j = 0; j < m_GOPListsMvc[k][i].m_numVSPRefPics; j++ )
+        {
+          Int iAbsViewId = m_GOPListsMvc[k][i].m_VSPRefPics[j] + k;
+          if( iAbsViewId != 0 )
+          {
+            printf( "\nError: VSP is allowed to reference only base view\n" );
+            bErrorVspEnhV = true;
+          }
+          if( m_GOPListsMvc[k][i].m_sliceType == 'P' && m_GOPListsMvc[k][i].m_VSPRefPosL1[j] != 0 )
+          {
+            printf( "\nError: m_sliceType == P and m_VSPRefPosL1 != 0\n" );
+            bErrorVspEnhV = true;
+          }
+        }
+
+        for( Int j = 0; j < m_GOPListsMvc[k][i].m_numVSPRefPics || j < m_GOPListsMvc[k][i].m_numInterViewRefPics; j++ )
+        {
+          if( (m_GOPListsMvc[k][i].m_VSPRefPosL0[j] != 0 && m_GOPListsMvc[k][i].m_VSPRefPosL0[j] == m_GOPListsMvc[k][i].m_interViewRefPosL0[j]) 
+           || (m_GOPListsMvc[k][i].m_VSPRefPosL1[j] != 0 && m_GOPListsMvc[k][i].m_VSPRefPosL1[j] == m_GOPListsMvc[k][i].m_interViewRefPosL1[j]) )
+          {
+            printf( "\nError: vsp_ref_list_pos[%d] == IV ref list pos[%d]\n", j, j );
+            bErrorVspEnhV = true;
+          }
+        }
+      }
+    }
+  }
+  xConfirmPara( bErrorVspEnhV, "Invalid VSP coding structure for enhancement views given" );
+#endif
 
   // validate temporal coding structure
@@ -1692,5 +1791,11 @@
 #if HHI_VSO
   printf("VSO:%d ", m_bUseVSO             );
-#endif  
+#endif
+#if LGE_WVSO_A0119
+  printf("WVSO:%d ", m_bUseWVSO );
+#endif
+#if OL_DEPTHLIMIT_A0044
+  printf("DPL:%d ", m_bDepthPartitionLimiting);
+#endif
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
   printf("DMM:%d ", m_bUseDMM );
@@ -1698,4 +1803,7 @@
 #if HHI_MPI
   printf("MVI:%d ", m_bUseMVI ? 1 : 0 );
+#endif
+#if LGE_WVSO_A0119
+  printf("\nVSO : VSD : SAD weight = %d : %d : %d ", m_iVSOWeight, m_iVSDWeight, m_iDWeight );
 #endif
   printf("\n\n");
Index: /branches/HTM-4.0.1-VSP-dev0/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 193)
@@ -297,8 +297,22 @@
   Bool      m_bUseEstimatedVSD;                           ///< Flag for using model based VSD estimation instead of VSO for some encoder decisions (JCT3V-A0033 modification 3)  
 #endif
+#if LGE_WVSO_A0119
+  Bool      m_bUseWVSO;                                    ///< flag for using View Synthesis Optimization  
+  Int       m_iVSOWeight;
+  Int       m_iVSDWeight;
+  Int       m_iDWeight;
+#endif
+#if VSP_N
+  Bool      m_bUseVSP;
+  Bool      m_bVSPDepthDisable;
+#endif
 
   // coding tools (depth intra modes)
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
   Bool      m_bUseDMM;                                        ///< flag for using DMM
+#endif
+
+#if OL_DEPTHLIMIT_A0044
+  Bool      m_bDepthPartitionLimiting;
 #endif
 
Index: /branches/HTM-4.0.1-VSP-dev0/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 193)
@@ -207,4 +207,7 @@
     m_acTEncTopList[iViewIdx]->setUseEstimatedVSD              ( false );
 #endif
+#if LGE_WVSO_A0119
+    m_acTEncTopList[iViewIdx]->setUseWVSO                      ( false ); 
+#endif
 #endif
 
@@ -361,6 +364,14 @@
     m_acTEncTopList[iViewIdx]->setUseDMM                     ( false );
 #endif
+#if OL_DEPTHLIMIT_A0044
+    m_acTEncTopList[iViewIdx]->setUseDPL                     ( false );
+#endif
 #if HHI_MPI
     m_acTEncTopList[iViewIdx]->setUseMVI( false );
+#endif
+
+#if VSP_N
+    m_acTEncTopList[iViewIdx]->setUseVSP( m_bUseVSP );
+    m_acTEncTopList[iViewIdx]->setVSPDepthDisable( m_bVSPDepthDisable );
 #endif
   }
@@ -524,4 +535,7 @@
       m_acTEncDepthTopList[iViewIdx]->setUseEstimatedVSD              ( m_bUseEstimatedVSD );
 #endif
+#if LGE_WVSO_A0119
+      m_acTEncDepthTopList[iViewIdx]->setUseWVSO                      ( m_bUseWVSO         );
+#endif
 #endif
 
@@ -634,6 +648,14 @@
     m_acTEncDepthTopList[iViewIdx]->setUseDMM                     ( m_bUseDMM );
 #endif
+#if OL_DEPTHLIMIT_A0044
+    m_acTEncDepthTopList[iViewIdx]->setUseDPL                      (m_bDepthPartitionLimiting);
+#endif
 #if HHI_MPI
      m_acTEncDepthTopList[iViewIdx]->setUseMVI( m_bUseMVI );
+#endif
+
+#if VSP_N
+      m_acTEncDepthTopList[iViewIdx]->setUseVSP( m_bUseVSP );
+      m_acTEncDepthTopList[iViewIdx]->setVSPDepthDisable( m_bVSPDepthDisable );
 #endif
     }
@@ -690,4 +712,17 @@
       AOT(true);
     }
+#if LGE_WVSO_A0119 
+    for ( Int iViewNum = 0; iViewNum < m_iNumberOfViews; iViewNum++ )
+    {
+      for (Int iContent = 0; iContent < 2; iContent++ )
+      {
+        TEncTop* pcEncTop = ( iContent == 0 ) ? m_acTEncTopList[iViewNum] : m_acTEncDepthTopList[iViewNum]; 
+        pcEncTop->setUseWVSO  ( m_bUseWVSO );
+        pcEncTop->setVSOWeight( m_iVSOWeight );
+        pcEncTop->setVSDWeight( m_iVSDWeight );
+        pcEncTop->setDWeight  ( m_iDWeight );
+      }
+    }
+#endif
   }
 #endif
@@ -938,7 +973,7 @@
         iNumEncoded = 0;
 
-#if VSP_SLICE_HEADER
-        m_acTEncTopList     [iViewIdx]->setUseVSP( (gopId%VSP_FRAME_INTERVAL==0) );
-        m_acTEncDepthTopList[iViewIdx]->setUseVSP( (gopId%VSP_FRAME_INTERVAL==0) );
+#if VSP_SLICE_HEADER && !VSP_CFG
+        if( m_acTEncTopList     [iViewIdx]->getUseVSP() ) m_acTEncTopList     [iViewIdx]->setUseVSP( (gopId%VSP_FRAME_INTERVAL==0) );
+        if( m_acTEncDepthTopList[iViewIdx]->getUseVSP() ) m_acTEncDepthTopList[iViewIdx]->setUseVSP( (gopId%VSP_FRAME_INTERVAL==0) );
 #endif
 
@@ -963,4 +998,5 @@
 #if VSP_SLICE_HEADER
           if( m_acTEncDepthTopList[iViewIdx]->getUseVSP() )
+          if( !m_acTEncDepthTopList[iViewIdx]->getVSPDepthDisable() )
 #endif
             xStoreVSPInBuffer(m_acTEncDepthTopList[iViewIdx]->getVSPBuf(), m_acTEncDepthTopList[iViewIdx]->getVSPAvailBuf(), iViewIdx, true, gopId);
@@ -1003,4 +1039,14 @@
   delete pcDepthPicYuvOrg;
   pcDepthPicYuvOrg = NULL;
+  
+#if FIX_MEM_LEAKS
+  if ( pcPdmDepthOrg != NULL )
+  {
+    pcPdmDepthOrg->destroy();
+    delete pcPdmDepthOrg;     
+    pcPdmDepthOrg = NULL; 
+  };
+#endif
+
   
   for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
@@ -1263,5 +1309,9 @@
 Void TAppEncTop::setupRenModel( Int iPoc, Int iEncViewIdx, Int iEncContent, Int iHorOffset )
 {
+#if FIX_VSO_SETUP
+  m_cRendererModel.setupPart( iHorOffset, Min( g_uiMaxCUHeight, m_iSourceHeight - iHorOffset ) ); 
+#else
   m_cRendererModel.setHorOffset( iHorOffset ); 
+#endif
 #else
 Void TAppEncTop::setupRenModel( Int iPoc, Int iEncViewIdx, Int iEncContent )
@@ -1410,9 +1460,5 @@
 {
   //first view does not have VSP 
-#if VSP_TEXT_ONLY
-  if((iCodedViewIdx == 0)||(bDepth))
-#else
   if((iCodedViewIdx == 0))
-#endif
     return;
 
@@ -1439,6 +1485,7 @@
   }
   pcPicVSP->getSlice(0)->setPOC( iCurPoc );
-
-  Int iNeighborViewId = 0;
+  pcPicVSP->getSlice(0)->setViewId( iCodedViewIdx );
+
+  Int iNeighborViewId = 0;  //iCodedViewIdx + m_GOPListsMvc[iCodedViewIdx][gopId].m_VSPRefPics[0];
   Bool bRenderFromLeft;
   //check if the neighboring view is situated to the left of the current view
Index: /branches/HTM-4.0.1-VSP-dev0/source/App/TAppRenderer/TAppRendererTop.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/App/TAppRenderer/TAppRendererTop.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/App/TAppRenderer/TAppRendererTop.cpp	(revision 193)
@@ -533,5 +533,9 @@
 
 #if HHI_VSO_SPEEDUP_A0033
+#if FIX_VSO_SETUP
+    cCurModel.setupPart( 0, m_iSourceHeight  ); 
+#else
     cCurModel.setHorOffset( 0 );
+#endif
 #endif
 
@@ -710,5 +714,9 @@
   AOT( m_iLog2SamplingFactor != 0 );
 #if HHI_VSO_SPEEDUP_A0033
+#if FIX_VSO_SETUP
+  cCurModel.setupPart( 0, m_iSourceHeight  ); 
+#else
   cCurModel.setHorOffset( 0 );
+#endif
 #endif
 #if LGE_VSO_EARLY_SKIP_A0093
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/CommonDef.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/CommonDef.h	(revision 193)
@@ -58,5 +58,5 @@
 
 #define HM_VERSION        "6.1"
-#define NV_VERSION        "4.0.1"                 ///< Current software version
+#define NV_VERSION        "4.1"                  ///< Current software version
 
 // ====================================================================================================================
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.cpp	(revision 193)
@@ -76,6 +76,8 @@
   if( ucVspMergePos == VSP_MERGE_POS )
   {
-#if VSP_TEXT_ONLY
-    if( !getSlice()->getSPS()->isDepth() )
+#if VSP_CFG
+    if( getSlice()->getSPS()->getVspDepthPresentFlag() || !getSlice()->getSPS()->isDepth() )
+#else
+    if( !getSlice()->getVspDepthDisableFlag() || !getSlice()->getSPS()->isDepth() )
 #endif
     if( getSlice()->getSPS()->getViewId()!=0 && !bVspMvZeroDone )
@@ -150,7 +152,10 @@
   m_pcTrCoeffCr        = NULL;
 #if ADAPTIVE_QP_SELECTION  
+#if FIX_MEM_LEAKS
+  m_ArlCoeffIsAliasedAllocation = false;
   m_pcArlCoeffY        = NULL;
   m_pcArlCoeffCb       = NULL;
   m_pcArlCoeffCr       = NULL;
+#endif
 #endif
   
@@ -211,4 +216,16 @@
   m_piEdgeDeltaDC1      = NULL;
 #endif
+#endif
+#if OL_DEPTHLIMIT_A0044
+  //add a variable to store the partition information
+  //a 2D array in part_symbol, uidepth format
+  //initialize m_partInfo to OL_END_CU
+  for (Int i=0; i < OL_PART_BUF_SIZE; i++)
+  {
+    for (Int j=0; j < 2; j++)
+    {
+      m_uiPartInfo[i][j] = OL_END_CU;
+    }
+  }
 #endif
 }
@@ -295,4 +312,7 @@
       m_pcArlCoeffCb       = m_pcGlbArlCoeffCb;
       m_pcArlCoeffCr       = m_pcGlbArlCoeffCr;
+#if FIX_MEM_LEAKS
+      m_ArlCoeffIsAliasedAllocation = true;
+#endif
     }
     else
@@ -410,4 +430,12 @@
     if ( m_pcTrCoeffCr        ) { xFree(m_pcTrCoeffCr);         m_pcTrCoeffCr       = NULL; }
 #if ADAPTIVE_QP_SELECTION
+#if FIX_MEM_LEAKS
+    if (!m_ArlCoeffIsAliasedAllocation)
+    {
+      xFree(m_pcArlCoeffY); m_pcArlCoeffY = 0;
+      xFree(m_pcArlCoeffCb); m_pcArlCoeffCb = 0;
+      xFree(m_pcArlCoeffCr); m_pcArlCoeffCr = 0;
+    }
+#endif
     if ( m_pcGlbArlCoeffY     ) { xFree(m_pcGlbArlCoeffY);      m_pcGlbArlCoeffY    = NULL; }
     if ( m_pcGlbArlCoeffCb    ) { xFree(m_pcGlbArlCoeffCb);     m_pcGlbArlCoeffCb   = NULL; }
@@ -516,4 +544,7 @@
 Void TComDataCU::initCU( TComPic* pcPic, UInt iCUAddr )
 {
+#if OL_DEPTHLIMIT_A0044
+  TComDataCU* pcCU     = pcPic->getCU(iCUAddr);
+#endif
 
   m_pcPic              = pcPic;
@@ -732,4 +763,7 @@
     m_apcCUColocated[1] = getSlice()->getRefPic( REF_PIC_LIST_1, 0)->getCU( m_uiCUAddr );
   }
+#if OL_DEPTHLIMIT_A0044
+  setPartDumpFlag (pcCU->getPartDumpFlag());
+#endif
 }
 
@@ -1061,4 +1095,7 @@
   memcpy(m_uiSliceStartCU,pcCU->m_uiSliceStartCU+uiPartOffset,sizeof(UInt)*m_uiNumPartition);
   memcpy(m_uiEntropySliceStartCU,pcCU->m_uiEntropySliceStartCU+uiPartOffset,sizeof(UInt)*m_uiNumPartition);
+#if OL_DEPTHLIMIT_A0044
+  setPartDumpFlag (pcCU->getPartDumpFlag());
+#endif
 }
 
@@ -2346,4 +2383,8 @@
 #if H0204_QP_PREDICTION
   UInt        lPartIdx, aPartIdx;
+#if FIX_COMP_WARNING_INIT
+  lPartIdx = 0; 
+  aPartIdx = 0;
+#endif
   TComDataCU* cULeft  = getQpMinCuLeft ( lPartIdx, m_uiAbsIdxInLCU + uiCurrAbsIdxInLCU );
   TComDataCU* cUAbove = getQpMinCuAbove( aPartIdx, m_uiAbsIdxInLCU + uiCurrAbsIdxInLCU );
@@ -3146,5 +3187,9 @@
     RefPicList eRefList = uiRefIdx ? REF_PIC_LIST_1 : REF_PIC_LIST_0;
     Int iBestRefIdx = getCUMvField(eRefList)->getRefIdx(uiPartAddr);
-    if(iBestRefIdx >= 0 && getSlice()->getViewId() == getSlice()->getRefViewId(eRefList, iBestRefIdx))
+    if(iBestRefIdx >= 0 && getSlice()->getViewId() == getSlice()->getRefViewId(eRefList, iBestRefIdx)
+#if VSP_N
+                        && getSlice()->getPOC() != getSlice()->getRefPOC(eRefList, iBestRefIdx)
+#endif
+      )
       iAddResiShift++;
   }
@@ -4614,7 +4659,4 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4625,5 +4667,11 @@
       {
         Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
+#if VSP_N & VSP_BUGFIX
+        Int refPOC = pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId);
+        //if( !pcTmpCU->isVspRef( eRefPicList, refId ) )
+        if ( refViewIdx!= m_pcSlice->getViewId() || refPOC != m_pcSlice->getPOC())
+#else
         if (refViewIdx!= m_pcSlice->getViewId())
+#endif
         {
            TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -4643,7 +4691,4 @@
 
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4654,5 +4699,11 @@
       {
         Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
+#if VSP_N & VSP_BUGFIX
+        Int refPOC = pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId);
+        //if( !pcTmpCU->isVspRef( eRefPicList, refId ) )
+        if ( refViewIdx!= m_pcSlice->getViewId() || refPOC != m_pcSlice->getPOC())
+#else
         if (refViewIdx!= m_pcSlice->getViewId())
+#endif
         {
            TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -4672,7 +4723,4 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4683,5 +4731,11 @@
       {
         Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
+#if VSP_N & VSP_BUGFIX
+        Int refPOC = pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId);
+        //if( !pcTmpCU->isVspRef( eRefPicList, refId ) )
+        if ( refViewIdx!= m_pcSlice->getViewId() || refPOC != m_pcSlice->getPOC())
+#else
         if (refViewIdx!= m_pcSlice->getViewId())
+#endif
         {
            TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -4700,7 +4754,4 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4711,5 +4762,11 @@
       {
         Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
+#if VSP_N & VSP_BUGFIX
+        Int refPOC = pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId);
+        //if( !pcTmpCU->isVspRef( eRefPicList, refId ) )
+        if ( refViewIdx!= m_pcSlice->getViewId() || refPOC != m_pcSlice->getPOC())
+#else
         if (refViewIdx!= m_pcSlice->getViewId())
+#endif
         {
            TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -4731,7 +4788,4 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4742,5 +4796,11 @@
       {
         Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
+#if VSP_N & VSP_BUGFIX
+        Int refPOC = pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId);
+        //if( !pcTmpCU->isVspRef( eRefPicList, refId ) )
+        if ( refViewIdx!= m_pcSlice->getViewId() || refPOC != m_pcSlice->getPOC())
+#else
         if (refViewIdx!= m_pcSlice->getViewId())
+#endif
         {
            TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -4965,7 +5025,4 @@
   UInt uiLeftPartIdx = uiIdx;
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -4985,5 +5042,9 @@
           return;
         }
+#if VSP_N & VSP_BUGFIX
+        else if (pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId) != m_pcSlice->getPOC()) // MCP 
+#else
         else // MCP 
+#endif
         {
           cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -5006,7 +5067,4 @@
 
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -5026,5 +5084,9 @@
           return;
         }
+#if VSP_N & VSP_BUGFIX
+        else if (pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId) != m_pcSlice->getPOC()) // MCP 
+#else
         else // MCP 
+#endif
         {
           cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -5046,7 +5108,4 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -5066,5 +5125,9 @@
           return;
         }
-        else  // MCP 
+#if VSP_N & VSP_BUGFIX
+        else if (pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId) != m_pcSlice->getPOC()) // MCP 
+#else
+        else // MCP 
+#endif
         {
           cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -5086,7 +5149,4 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -5106,5 +5166,9 @@
           return;
         }
+#if VSP_N & VSP_BUGFIX
+        else if (pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId) != m_pcSlice->getPOC()) // MCP 
+#else
         else // MCP 
+#endif
         {
           cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -5128,7 +5192,4 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
-#if VSP_N
-  if(pcTmpCU->getSlice()->getViewId() != NUM_VIEW_VSP)
-#endif
   {
     bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
@@ -5148,5 +5209,9 @@
           return;
         }
+#if VSP_N & VSP_BUGFIX
+        else if (pcTmpCU->getSlice()->getRefPOC( eRefPicList, refId) != m_pcSlice->getPOC()) // MCP 
+#else
         else // MCP 
+#endif
         {
           cTmpMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
@@ -5753,5 +5818,5 @@
   {
     aiRefIdx[iList] = getCUMvField( RefPicList(iList) )->getRefIdx( uiPartIdx );
-    if( aiRefIdx[iList] >= 0 && getSlice()->getRefViewId( RefPicList(iList), aiRefIdx[iList] ) == NUM_VIEW_VSP )
+    if( aiRefIdx[iList] >= 0 && isVspRef( RefPicList(iList), aiRefIdx[iList] ) )
     {
       iRet |= (iList ? 0x02 : 0x01); // L0=1, L1=2, BI=3
@@ -5802,4 +5867,17 @@
   return iRet; 
 }
+
+Bool TComDataCU::isVspRef ( RefPicList e, Int iRefIdx )
+{
+  if( iRefIdx < 0 ) return false;
+
+  if( getSlice()->getRefPic( e, iRefIdx )->getViewId() == getSlice()->getViewId()
+   && getSlice()->getRefPic( e, iRefIdx )->getPOC()    == getSlice()->getPOC()   )
+  {
+    return true;
+  }
+
+  return false;
+}
 #endif
 
@@ -5866,5 +5944,5 @@
  
 #if AMVP_VSP_UNAVAILABLE
-  if( pcTmpCU != NULL && pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) >= 0 && pcTmpCU->getSlice()->getRefViewId( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) == NUM_VIEW_VSP )
+  if( pcTmpCU != NULL && pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) >= 0 && pcTmpCU->isVspRef( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) )
   {
     return false;
@@ -5908,4 +5986,8 @@
       return false;
     }
+#if VSP_N ///
+    if( pcTmpCU->isVspRef( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) ) )
+      return false;
+#endif
     iNeibRefPOC = pcTmpCU->getSlice()->getRefPOC( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) );
     if( iNeibRefPOC == iCurrRefPOC ) // Same Reference Frame But Diff List//
@@ -6035,5 +6117,5 @@
 
 #if AMVP_VSP_UNAVAILABLE
-  if( pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) >= 0 && pcTmpCU->getSlice()->getRefViewId( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) == NUM_VIEW_VSP )
+  if( pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) >= 0 && pcTmpCU->isVspRef( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) )
   {
     return false;
@@ -6061,4 +6143,8 @@
     if( pcTmpCU->getSlice()->getRefViewId( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) ) != m_pcSlice->getRefViewId( eRefPicList, iRefIdx ) )
       return false;
+#if VSP_N ///
+    if( pcTmpCU->isVspRef( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) ) )
+      return false;
+#endif
     if( iNeibRefPOC == iCurrRefPOC ) // Same Reference Frame But Diff List//
     {
@@ -6084,7 +6170,11 @@
       return false;
     }
+#if VSP_N ///
+    if( pcTmpCU->isVspRef( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) )
+      return false;
+#endif
 
 #if VSP_N
-    if( pcTmpCU->getSlice()->getRefViewId( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) == NUM_VIEW_VSP )
+    if( pcTmpCU->isVspRef( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ) )
     {
       bRefVsp = true;
@@ -6119,7 +6209,11 @@
       return false;
     }
+#if VSP_N ///
+    if( pcTmpCU->isVspRef( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) ) )
+      return false;
+#endif
 
 #if VSP_N
-    if( pcTmpCU->getSlice()->getRefViewId( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) ) == NUM_VIEW_VSP )
+    if( pcTmpCU->isVspRef( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) ) )
     {
       bRefVsp = true;
@@ -6161,23 +6255,13 @@
   Int iColViewIdx, iColRefViewIdx;
   TComPic *pColPic = getSlice()->getRefPic( eRefPicList, refidx);
-#if VSP_MV_ZERO // shimizu
+#if VSP_N
+  if( pColPic->getSlice(0)->getViewId() == getSlice()->getViewId() && pColPic->getSlice(0)->getPOC() == getSlice()->getPOC() )
+  {
+    return false;
+  }
+#endif
   TComDataCU *pColCU = pColPic->getCU( uiCUAddr );
   iColViewIdx = pColCU->getSlice()->getViewId();
-#if VSP_N
-  if( iColViewIdx == NUM_VIEW_VSP )
-  {
-    return false;
-  }
-#endif
-#else  
-#if VSP_N
-  if( pColPic->getSlice(0)->getViewId() == NUM_VIEW_VSP )
-  {
-    return false;
-  }
-#endif
-  TComDataCU *pColCU = pColPic->getCU( uiCUAddr );
-  iColViewIdx = pColCU->getSlice()->getViewId();
-#endif
+
 
   if (pColCU->getPic()==0||pColCU->getPartitionSize(uiPartUnitIdx)==SIZE_NONE||pColCU->isIntra(uiAbsPartAddr))
@@ -6207,5 +6291,5 @@
     iColRefViewIdx = pColCU->getSlice()->getRefPic(eColRefPicList, iColRefIdx)->getViewId();
 #if VSP_N
-    if( iColRefViewIdx == NUM_VIEW_VSP )
+    if( iColRefViewIdx == pColCU->getSlice()->getViewId() && pColCU->getSlice()->getRefPic(eColRefPicList, iColRefIdx)->getPOC() == pColCU->getSlice()->getPOC() )
     {
       continue;
@@ -6351,5 +6435,5 @@
 //  UInt uiColRefViewId = pColCU->getSlice()->getRefPic( eColRefPicList, pColCU->getCUMvField(eColRefPicList)->getRefIdx(uiAbsPartAddr))->getViewId();
   UInt uiCurRefViewId = m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getViewId();
-  if( uiCurRefViewId == NUM_VIEW_VSP )
+  if( uiCurRefViewId == m_pcSlice->getViewId() && m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getPOC() == m_pcSlice->getPOC() )
     iScale = 4096;
   else
@@ -6368,5 +6452,5 @@
   {
 #if VSP_MV_ZERO
-    if( uiCurRefViewId == NUM_VIEW_VSP )
+    if( uiCurRefViewId == m_pcSlice->getViewId() && m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getPOC() == m_pcSlice->getPOC() )
       rcMv.setZero();
     else
@@ -6481,4 +6565,10 @@
     return false;
   }
+#if VSP_N ///
+  if( isVspRef( eRefPicList, iRefIdx ) )
+  {
+    return false;
+  }
+#endif
 
   // Prefer a vector crossing us.  Prefer shortest.
@@ -6495,4 +6585,9 @@
     }
     int iColRefPOC = pColCU->getSlice()->getRefPOC(RefPicList(l), iColRefIdx);
+#if VSP_N ///
+    Bool bColVsp    = pColCU->isVspRef( RefPicList(getSlice()->isInterB() ? getSlice()->getColDir() : 0), getSlice()->getColRefIdx() );
+    Bool bColRefVsp = pColCU->isVspRef( RefPicList(l), iColRefIdx );
+    if( ( bColRefVsp && !bColVsp) || (!bColRefVsp &&  bColVsp) )
+#endif
     if( pColCU->getSlice()->getRefViewId( RefPicList(l), iColRefIdx ) != pColCU->getSlice()->getViewId() )
     {
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 193)
@@ -159,4 +159,7 @@
   Int*          m_pcArlCoeffCb;       ///< ARL coefficient buffer (Cb)
   Int*          m_pcArlCoeffCr;       ///< ARL coefficient buffer (Cr)
+#if FIX_MEM_LEAKS
+  Bool          m_ArlCoeffIsAliasedAllocation; ///< ARL coefficient buffer is an alias of the global buffer and must not be free()'d
+#endif 
 
   static Int*   m_pcGlbArlCoeffY;     ///< ARL coefficient buffer (Y)
@@ -237,4 +240,12 @@
   UInt*         m_uiSliceStartCU;    ///< Start CU address of current slice
   UInt*         m_uiEntropySliceStartCU; ///< Start CU address of current slice
+
+#if OL_DEPTHLIMIT_A0044 
+  //add a variable to store the partition information
+  //a 2D array in uidepth, part_symbol format
+  UInt          m_uiPartInfo[OL_PART_BUF_SIZE][2];
+  UInt          m_uiPartNum;
+  Bool          m_dumpPartInfo;
+#endif 
   
   // -------------------------------------------------------------------------------------------------------------------
@@ -600,4 +611,13 @@
   
   Void          compressMV            ();
+
+#if OL_DEPTHLIMIT_A0044
+  Void        resetPartInfo     () {m_uiPartNum = 0;};
+  Void        incrementPartInfo () {m_uiPartNum ++;};
+  Void        updatePartInfo(UInt uiSymbol, UInt uiDepth) { m_uiPartInfo[m_uiPartNum][0] = uiSymbol; m_uiPartInfo[m_uiPartNum][1] = uiDepth;};
+  UInt*       readPartInfo()                              { return (UInt*)m_uiPartInfo;};
+  Void        setPartDumpFlag(Bool flag)                  { m_dumpPartInfo = flag; };
+  Bool        getPartDumpFlag()                           { return m_dumpPartInfo; };
+#endif
   
   // -------------------------------------------------------------------------------------------------------------------
@@ -665,4 +685,5 @@
   Int           isVspMode ( UInt uiPartIdx );
   Int           isVspMode ( UInt uiPartIdx, TComMv cCompMv );
+  Bool          isVspRef  ( RefPicList e, Int iRefIdx );
 #endif
   
